#!/bin/bash
# $Id: uade-kLauncher.sh,v 1.3 2004/06/30 09:58:36 mld Exp $

## vars
DIALOG=${DIALOG=kdialog}
tempfile=`tempfile 2>/dev/null` || tempfile=/tmp/uadeklauncher$$
echo "none" > $tempfile
uadecommand=""
uadepid="no"
uadestatus="stopped"
UADEEXE="$HOME/.xmms/uade/uade -int -repeat -force"
UADECMD="$UADEEXE"
UADEINFO="no info available"
filename="<none>"
filepwd=""
subsong="0"


# -------------------------------------------------------------------------
function killuade {
# parameters:
# none
# return:
# none
# -------------------------------------------------------------------------
   if [ "$uadepid" != "no" ];then  
     kill $uadepid
        uadepid="no"
	uadestatus="stopped"
   fi
}

# -------------------------------------------------------------------------
function openfile {
# parameters:
# $1 filename
# return:
# $retval
# -------------------------------------------------------------------------
if [ "$1" = "" ];then
   $DIALOG --title "UADE kLauncher (Open File...)" \
   --getopenfilename "$filepwd" > "$tempfile" 1>&1
   retval=$?
else
 echo "$@" >"$tempfile"
 retval=0
fi

case $retval in
  0)
  filepath=`cat "$tempfile"`
  filename=`cat "$tempfile" | sed 's/.*\(\/\\)//'` #strip path
  filepwd=`cat "$tempfile" |sed 's/[^/]*$//'` #strip filename
  subsong="0"
  UADECMD="$UADEEXE"
  playfile
  ;;
  1)
    echo "Cancel pressed.";;
  255)
    if test -s $tempfile ; then
      cat $tempfile
    else
      echo "ESC pressed."
    fi
    ;;
esac
}

# -------------------------------------------------------------------------
function playfile {
# parameters:
# none
# return:
# none
# -------------------------------------------------------------------------
    killuade
    $UADECMD "$filepath" >/dev/null 2>&1&
    uadepid=`echo $!`
    uadestatus="playing..."
}
# -------------------------------------------------------------------------
function exituade {
# parameters:
# none
# return:
# none
# -------------------------------------------------------------------------
    killuade
    trap "rm -f $tempfile" 0 1 2 5 15
    exit 0
}


#### main 

## filename given, or request file
openfile "$1"

while :
do
    $DIALOG --title "UADE kLauncher ($cat $filename)" \
          --menu "--=[ UADE - Unix Amiga Delitracker Emulator ]=--
	
	Filename: $filename
	Status: $uadestatus
	Subsong: $subsong"\
	"play" "Play" \
	"stop" "Stop" \
	"next" "Next Subsong"\
	"prev" "Previous Subsong"\
	"open" "Open new song"\
	"exit" "Exit" >$tempfile 1>&1
      retval=$?
      uadecommand="$(cat $tempfile)"


 case $retval in
  0)

## stop file
  if [ "$uadecommand" = "stop" ];then
   killuade
  fi


## play file
  if [ "$uadecommand" = "play" ];then
        playfile
  fi

   if [ "$uadecommand" = "next" ];then
    subsong=`echo $[$subsong+1]`
    UADECMD="$UADEEXE -sub $subsong"
    playfile
   fi

    if [ "$uadecommand" = "prev" ];then
      if [ "$subsong" != "0" ];then
      subsong=`echo $[$subsong-1]`
           if [ "$subsong" != "0" ];then
            UADECMD="$UADEEXE -sub $subsong"
           else
            UADECMD="$UADEEXE"
	   fi
      playfile
     fi
    fi
   
   if [ "$uadecommand" = "open" ];then
    openfile ""
   fi

   if [ "$uadecommand" = "exit" ];then
    exituade
   fi
   ;;
  1)
    exituade
   ;;
  255)
      exituade
   ;;
 esac
done